/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var Prefs = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService).getBranch("conquery04.");


/////////////////////////////////////////////////////////////////////////////////////
////////   Single_entry holder and all_entries holder classes  /////////////////////
function _Clone(){
  var NewObj = new Object();
  for (var oP in this) NewObj[oP]=this[oP];
  return NewObj;
}

function _StoreInput(inp){
//var iholder = new Object();
  var haslist = false;
	lst = new Object();
	inobj = new Object();
	inobj.name = String(inp.name);
	inobj.value = String(inp.value);
	if (inp.label) {inobj.label=inp.label} else {inobj.label=""};
	if (inp.grouptitle) {inobj.grouptitle=inp.grouptitle} else {inobj.grouptitle=""};
	inobj.priority = String(inp.priority);
	ItemName = inp.name;
	//ItemName = String(inp.priority);
	
	if (this.Inputs!=null){
		if (this.Inputs[ItemName]){
			haslist = true;
			if (!this.Inputs[ItemName].list) this.Inputs[ItemName].list = new Object();
			this.Inputs[ItemName].list[inp.priority] = inobj;
		}else{
			this.Inputs[ItemName] = new Object();
			this.Inputs[ItemName] = inobj;
			//this.Inputs[ItemName].list = new Object();
			//this.Inputs[ItemName].list[inp.priority] = inobj;
		}
	}else{
		this.Inputs = new Object();
		this.Inputs[ItemName] = new Object();
		this.Inputs[ItemName] = inobj;
	}
  return haslist;
}

function ProtoEntry() {
  this.eId =  "";
  this.Title =  "";
  this.URL =  "";
  this.Action =  "";
  this.Method =  "";
  this.Desc =  "";
  //this.Inputs = new Object;
  this.Context = "";
  this.filepath = "";
  this.haslist = false;
  this._Clone = _Clone;
  this._StoreInput = _StoreInput;
}
ProtoEntry.prototype = ProtoEntry;

//Entries holder:
function _AddEntryObj(EntryObj, eId){
	if (!eId){
		var i = 0;
		eId = "";
		while(!eId){
			if (!this[i]){eId = i}
			i++;
		}
	}
	if (!EntryObj.Title) EntryObj.Title = "Conquery Error!";
	if (!EntryObj.Method) Method = "GET";
	if (EntryObj.Context=="") Context = false;
  EntryObj.eId = eId;
  this[eId] = EntryObj._Clone();
  return eId;
}

function _Exist(KeyName){
  var exst=false;
  if (this[KeyName]) exst=true; 
  return exst;
}
function _Item(KeyName){
	return this[KeyName];
}
function _Rm(Key){
    delete this[Key];
}
function _Items(){
try{
  //Getting items which has numeric key
  var items = [];
  //there is something wrong with isNaN function... doesn't work for me
  for (item in this) if (String(parseFloat(item))!="NaN") items[items.length] = this[item];
  items.sort(this._Cmp);
  return items;
}catch(er){cqerr(er, "_Items method")}
}
function _Cmp(a, b){
  if (a.Title.toLowerCase() > b.Title.toLowerCase()){return 1;}
  else if (a.Title.toLowerCase() < b.Title.toLowerCase()) {return -1;}
  else {return 0;}
}
function _Clear(){
  for (item in this) if (item.substr(0,1) != "_")	delete this[item];
}

function ProtoHash(){
	this._AddEntryObj = _AddEntryObj;
	this._Exist = _Exist;
	this._Item = _Item;
	this._Items = _Items;
	this._Rm = _Rm;
	this._Cmp = _Cmp;
	this._Clear = _Clear;
	this._Clone = _Clone;
}
ProtoHash.prototype = ProtoHash;
//////// END classes ////////


//Active Entries holder
var EntryHash = new ProtoHash();
//Repository Entries holder
var repEntryHash = new ProtoHash();

function cqerr(r, msg){
alert ("ConQuery failed:\n"+msg+"\n"+r);
}